(* expects:
  - type state
  - a function ai_init : world -> state
  - a function ai_step : world -> state -> state * direction *)

let main world ghost_codes =
  let ai_init : world -> state = ai_init in
  let ai_step : world -> state -> state * direction = ai_step in
  let world = retrieve_world world in
  (*  let _ = ghosts_program_retrieve ghost_codes in *)
  let init = ai_init world in
  cons (value init)
    (value (fun state world ->
         let world = retrieve_world world in
         let new_state, new_direction = ai_step world (magic state) in
         let new_direction =
           match new_direction with Up -> 0 | Right -> 1 | Down -> 2 | Left -> 3 in
         cons (value new_state) (value new_direction)))
